var gSearchBox;
var gMatchList;
var gMethodList;
var gClearButton;
var gTipBox;

var Cc = Components.classes;
var Ci = Components.interfaces;

if (!gPref) {
  var gPref = Cc["@mozilla.org/preferences-service;1"]
              .getService(Ci.nsIPrefBranch)
              .QueryInterface(Ci.nsIPrefBranch);
}

var xsbHistory = {

  initPanel : function () {
    window.removeEventListener("load", xsbHistory.initPanel, true);
    gSearchBox = document.getElementById("search-box");
    gClearButton = document.getElementById("clearSearch");

    // gSearchBox.focus(); xSidebar Bug 19286

    gTipBox = new Array;
    gTipBox.nameBox = document.getElementById("xsbHistTipNameBox");
    gTipBox.locBox = document.getElementById("xsbHistTipLocBox");
    gTipBox.visitBox = document.getElementById("xsbHistTipVisitBox");
    gTipBox.firstVisitBox = document.getElementById("xsbHistTipFirstVisitBox");
    gTipBox.hostBox = document.getElementById("xsbHistTipHostBox");
    gTipBox.referrerBox = document.getElementById("xsbHistTipReferrerBox");
    gTipBox.visitCountBox = document.getElementById("xsbHistTipVisitCountBox");

    gTipBox.nameValue = document.getElementById("xsbHistTipNameValue");
    gTipBox.locValue = document.getElementById("xsbHistTipLocValue");
    gTipBox.visitValue = document.getElementById("xsbHistTipVisitValue");
    gTipBox.firstVisitValue = document.getElementById("xsbHistTipFirstVisitValue");
    gTipBox.hostValue = document.getElementById("xsbHistTipHostValue");
    gTipBox.referrerValue = document.getElementById("xsbHistTipReferrerValue");
    gTipBox.visitCountValue = document.getElementById("xsbHistTipVisitCountValue");
  },

  initMgr : function () {
    window.removeEventListener("load", xsbHistory.initMgr, true);
    gSearchBox = document.getElementById("search-box");
    gMatchList = document.getElementById("xsb-matchList");
    gMethodList = document.getElementById("xsb-methodList");
    gClearButton = document.getElementById("clearSearch");
    xsbHistory.initSettings();
    xsbHistory.addPrefObserver();
    xSidebar.extensionStartup();
/* XXX: Why does this work only if put in the onload event?
 * The original setRoot() comes from history.js which is included from
 * historyTreeOverlay.js and not history.js
*/
    setRoot = function setRoot(root) {
      xsbHistory.setRoot(root);
    }
    if (!gHistoryGrouping ||
       ("arguments" in window && window.arguments[0] && window.arguments.length >= 1)) {
      try {
        gHistoryGrouping = gPrefService.getCharPref("browser.history.grouping");
      }
      catch(e) {
        gHistoryGrouping = "day";
      }
      switch(gHistoryGrouping) {
      case "none":
        document.getElementById("groupByNone").setAttribute("checked", "true");
        break;
      case "site":
        document.getElementById("groupBySite").setAttribute("checked", "true");
        break;
      case "day":
      default:
        document.getElementById("groupByDay").setAttribute("checked", "true");
      }
      xsbHistory.setRoot(window.arguments[0]);
    }
  },

  initSettings : function () {
    var showsearchbar = gPref.getBoolPref("extensions.xsidebar.history.manager.showsearchbar");
    var showadvanced = gPref.getBoolPref("extensions.xsidebar.history.manager.showadvancedsearch");
    xSidebar.showItem("xsb-history-searchbar", showsearchbar);
    xSidebar.showItem("xsb-advancedsearch-box", showadvanced);
    xSidebar.showItem("groupingMenu", "true");
  },

  unloadMgr : function () {
    xsbHistory.removePrefObserver();
  },

  /// From Firefox
  searchHistory : function (aInput) {
    xsbHistory.setClearButton(aInput);
    if (aInput == "") {
      xsbHistory.GroupBy(gHistoryGrouping);
      return;
    }
    xsbHistory.GroupBy("find:datasource=history&match=Name&method=contains&text=" + encodeURIComponent(aInput));     
  },

  GroupBy : function (groupingType) {
    var isFind = (groupingType.substr(0, 5) == "find:");
    if (!isFind) {
      gHistoryGrouping = groupingType;
      gSearchBox.value = "";
    }
    switch(groupingType) {
      case "site":
        gHistoryTree.setAttribute("ref", "NC:HistoryRoot");
        break;
      case "dayandsite":
        gHistoryTree.setAttribute("ref", "NC:HistoryByDateAndSite");
        break;
      case "visited":
        gHistoryTree.setAttribute("ref", "NC:HistoryRoot");
        break;
      case "lastvisited":
        gHistoryTree.setAttribute("ref", "NC:HistoryRoot");
        break;
      case "day":
        gHistoryTree.setAttribute("ref", "NC:HistoryByDate");
        break;
      default:
        gHistoryTree.setAttribute("ref", groupingType);
    }
    switch(isFind? gHistoryGrouping : groupingType) {
      case "site":
      case "dayandsite":
      case "day":
        xsbHistory.SortBy("name");
        break;
      case "lastvisited":
        xsbHistory.SortBy("lastvisited");
        break;
      case "visited":
        xsbHistory.SortBy("visited");
        break;
    }
  },

  SortBy : function (sortKey) {
  // We set the sortDirection to the one before we actually want it to be in the
  // cycle list, since cycleHeader cycles it forward before doing the sort.

    var sortDirection;
    switch(sortKey) {
      case "visited":
        sortKey = "rdf:http://home.netscape.com/NC-rdf#VisitCount";
        sortDirection = "ascending";
        break;
      case "name":
        sortKey = "rdf:http://home.netscape.com/NC-rdf#Name?sort=true";
        sortDirection = "natural";
        break;
      case "lastvisited":
        sortKey = "rdf:http://home.netscape.com/NC-rdf#Date";
        sortDirection = "ascending";
        break;
      default:
        return;    
    }
    var col = document.getElementById("Name");
    col.setAttribute("sort", sortKey);
    col.setAttribute("sortDirection", sortDirection);
    var column = gHistoryTree.columns.getColumnFor(col);
    gHistoryTree.view.cycleHeader(column);
  },

  /// Advanced Search options from findHistory
  searchHistoryManager : function (aInput) {
    xsbHistory.setClearButton(aInput);
    if (aInput == "") {
      xsbHistory.GroupBy(gHistoryGrouping);
      return;
    }
    else if (!xsbHistory.advancedSearchMode()) {
      xsbHistory.GroupBy("find:datasource=history&match=Name&method=contains&text=" + encodeURIComponent(aInput));     
    }
    else {
      var searchURI = "find:datasource=history"
      searchURI += "&match=" + gMatchList.selectedItem.value;
      searchURI += "&method=" + gMethodList.selectedItem.value;
      searchURI += "&text=" + encodeURIComponent(aInput);
      xsbHistory.GroupBy(searchURI);     
    }
  },

  advancedSearchMode : function (isAdvanced) {
    var advbox = document.getElementById("xsb-advancedsearch-box");
    if (isAdvanced != null) {
      advbox.hidden = !isAdvanced;
    }
    return !advbox.hidden;
  },

  setRoot : function (root) {
    gHistoryTree.ref = root;
    var findVars = root.split("&");
    for (ii = 0; ii < findVars.length; ii++) {
      findVars[ii] = findVars[ii].split("=")[1];
    }
    dump("setRoot :"+findVars+"\n");
    gMatchList.value = findVars[1];
    gMethodList.value = findVars[2];
    gSearchBox.value = decodeURIComponent(findVars[3]);
    gClearButton.setAttribute("disabled", "false");
  },

  /// From AIOS
  clearSearch : function() {
    gSearchBox.value = "";
    gSearchBox.focus();
    xsbHistory.searchHistory(gSearchBox.value);
  },

  /// xSidebar additions
  setClearButton : function (aInput) {
    gClearButton.setAttribute("disabled", (aInput == "") ? "true" : "false");
  },

  /// Tooltips

  FillInHistTooltip : function (aEvent, target) {

    var rv = false;

    gTipBox.nameBox.hidden = true;
    gTipBox.locBox.hidden = true;
    gTipBox.visitBox.hidden = true;
    gTipBox.firstVisitBox.hidden = true;
    gTipBox.hostBox.hidden = true;
    gTipBox.referrerBox.hidden = true;
    gTipBox.visitCountBox.hidden = true;

    gTipBox.nameValue.value = "";
    gTipBox.locValue.value = "";
    gTipBox.visitValue.value = "";
    gTipBox.firstVisitValue.value = "";
    gTipBox.hostValue.value = "";
    gTipBox.referrerValue.value = "";
    gTipBox.visitCountValue.value = "";

    var curRow = gHistoryTree.treeBoxObject.getRowAt(aEvent.clientX, aEvent.clientY);

    var current = new Array;
    current.rowIsContainer = isContainer(gHistoryTree, curRow);
    current.name = "";
    current.location = "";
    current.lastVisit = "";
    current.firstVisit = "";
    current.host = "";
    current.referrer = "";
    current.visitCount = "";

    current.name = gHistoryTree
                   .view.getCellText(curRow, gHistoryTree.columns["Name"]);
    if (current.name) {
      gTipBox.nameValue.value = current.name;
      gTipBox.nameBox.hidden = false;
      rv = true;
    }
    if (current.rowIsContainer) {
      return rv;
    }
    current.location = gHistoryTree
                   .view.getCellText(curRow, gHistoryTree.columns["URL"]);
    if (current.location) {
      gTipBox.locValue.value = current.location;
      gTipBox.locBox.hidden = false;
    }
    current.lastVisit = gHistoryTree
                   .view.getCellText(curRow, gHistoryTree.columns["Date"]);
    if (current.lastVisit) {
      gTipBox.visitValue.value = current.lastVisit;
      gTipBox.visitBox.hidden = false;
    }
    current.firstVisit = gHistoryTree
                   .view.getCellText(curRow, gHistoryTree.columns["FirstVisitDate"]);
    if (current.firstVisit) {
      gTipBox.firstVisitValue.value = current.firstVisit;
      gTipBox.firstVisitBox.hidden = false;
    }
    current.host = gHistoryTree
                   .view.getCellText(curRow, gHistoryTree.columns["Hostname"]);
    if (current.host) {
      gTipBox.hostValue.value = current.host;
      gTipBox.hostBox.hidden = false;
    }
    current.referrer = gHistoryTree
                   .view.getCellText(curRow, gHistoryTree.columns["Referrer"]);
    if (current.referrer) {
      gTipBox.referrerValue.value = current.referrer;
      gTipBox.referrerBox.hidden = false;
    }
    current.visitCount = gHistoryTree
                   .view.getCellText(curRow, gHistoryTree.columns["VisitCount"]);
    if (current.visitCount) {
      gTipBox.visitCountValue.value = current.visitCount;
      gTipBox.visitCountBox.hidden = false;
    }
    return rv;
  },

  /// Preferences

  prefObserver : {
    observe: function(subject, topic, data) {
    // subject is the nsIPrefBranch we're observing (after appropriate QI)
    // data is the name of the pref that's been changed (relative to subject)
      if(topic == "nsPref:changed")
        xsbHistory.initSettings();
    },

    QueryInterface : function (aIID) {
      if (aIID.equals(Ci.nsIObserver) || 
      aIID.equals(Ci.nsISupports) ||
      aIID.equals(Ci.nsISupportsWeakReference))
        return this;
      throw Components.results.NS_NOINTERFACE;
    }
  },

  addPrefObserver : function () {
    xSidebar.gPref.addObserver("extensions.xsidebar.history.manager.", xsbHistory.prefObserver, true);
  },

  removePrefObserver : function () {
    if (!xSidebar.gPref) return;
    xSidebar.gPref.removeObserver("extensions.xsidebar.history.manager.", xsbHistory.prefObserver);
  }

}
